/*
codr: timiter
task: cube
lang: C++
*/

#include <cstdio>
#include <cstring>
#include <queue>

using namespace std;

int sx, sy, ex, ey, f, x, y;
int sum[32][32], sts[32][32], o[32][32][8], d[8];
char s[4];
queue<int> q;

bool dbfs();

int main()
{
	int i, j;
	for (i = 0; i < 28; i++)
	{
		for (j = 0; j < 28; j++)
		{
			sts[i][j] = 0;
		}
	}
	for (i = 0; i < 28; i++)
	{
		sts[0][i] = -1;
		sts[27][i] = -1;
		sts[i][0] = -1;
		sts[i][27] = -1;
	}
	scanf("%s", s);
	sy = s[0] - 'a' + 1;
	if (strlen(s) == 3)
	{
		sx = (s[1] - '0') * 10 + s[2] - '0';
	}
	else
	{
		sx = s[1] - '0';
	}
	scanf("%s", s);
	ey = s[0] - 'a' + 1;
	if (strlen(s) == 3)
	{
		ex = (s[1] - '0') * 10 + s[2] - '0';
	}
	else
	{
		ex = s[1] - '0';
	}
	for (i = 0; i < 6; i++)
	{
		o[sx][sy][i] = i;
		scanf("%d", &d[i]);
	}
	f = d[0];
	d[0] = d[1];
	d[1] = f;
	f = d[3];
	d[3] = d[5];
	d[5] = f;
	scanf("%d", &f);
	for (i = 0; i < f; i++)
	{
		scanf("%s", s);
		y = s[0] - 'a' + 1;
		if (strlen(s) == 3)
		{
			x = (s[1] - '0') * 10 + s[2] - '0';
		}
		else
		{
			x = s[1] - '0';
		}
		sts[x][y] = -1;
	}
	sum[sx][sy] = d[o[sx][sy][4]];
	sts[sx][sy] = 1;
	if (dbfs())
	{
		printf("%d\n", sum[ex][ey]);
	}
	else
	{
		printf("-1\n");
	}
    return 0;
}

bool dbfs()
{
	int w, wx, wy;
	q.push((sx - 1) * 26 + sy);
	while (sts[ex][ey] == 0)
	{
		w = q.front();
		wx = w / 26 + 1;
		wy = w % 26;
		if (wy == 0)
		{
			wx--;
			wy = 26;
		}
		if (sts[wx + 1][wy] == 0 || (sts[wx + 1][wy] == 1 && sum [wx + 1][wy] > sum[wx][wy] + d[o[wx][wy][1]]))
		{
			sts[wx + 1][wy] = 1;
			q.push(wx * 26 + wy);
			o[wx + 1][wy][0] = o[wx][wy][4];
			o[wx + 1][wy][1] = o[wx][wy][2];
			o[wx + 1][wy][2] = o[wx][wy][0];
			o[wx + 1][wy][3] = o[wx][wy][3];
			o[wx + 1][wy][4] = o[wx][wy][1];
			o[wx + 1][wy][5] = o[wx][wy][5];
			sum[wx + 1][wy] = sum[wx][wy] + d[o[wx + 1][wy][4]];
		}
		if (sts[wx][wy + 1] == 0 || (sts[wx][wy + 1] == 1 && sum [wx][wy + 1] > sum[wx][wy] + d[o[wx][wy][3]]))
		{
			sts[wx][wy + 1] = 1;
			q.push((wx - 1) * 26 + wy + 1);
			o[wx][wy + 1][0] = o[wx][wy][0];
			o[wx][wy + 1][1] = o[wx][wy][1];
			o[wx][wy + 1][2] = o[wx][wy][5];
			o[wx][wy + 1][3] = o[wx][wy][2];
			o[wx][wy + 1][4] = o[wx][wy][3];
			o[wx][wy + 1][5] = o[wx][wy][4];
			sum[wx][wy + 1] = sum[wx][wy] + d[o[wx][wy + 1][4]];
		}
		if (sts[wx - 1][wy] == 0 || (sts[wx - 1][wy] == 1 && sum [wx - 1][wy] > sum[wx][wy] + d[o[wx][wy][0]]))
		{
			sts[wx - 1][wy] = 1;
			q.push((wx - 2) * 26 + wy);
			o[wx - 1][wy][0] = o[wx][wy][2];
			o[wx - 1][wy][1] = o[wx][wy][4];
			o[wx - 1][wy][2] = o[wx][wy][1];
			o[wx - 1][wy][3] = o[wx][wy][3];
			o[wx - 1][wy][4] = o[wx][wy][0];
			o[wx - 1][wy][5] = o[wx][wy][5];
			sum[wx - 1][wy] = sum[wx][wy] + d[o[wx - 1][wy][4]];
		}
		if (sts[wx][wy - 1] == 0 || (sts[wx][wy - 1] == 1 && sum [wx][wy - 1] > sum[wx][wy] + d[o[wx][wy][5]]))
		{
			sts[wx][wy - 1] = 1;
			q.push((wx - 1) * 26 + wy - 1);
			o[wx][wy - 1][0] = o[wx][wy][0];
			o[wx][wy - 1][1] = o[wx][wy][1];
			o[wx][wy - 1][2] = o[wx][wy][3];
			o[wx][wy - 1][3] = o[wx][wy][4];
			o[wx][wy - 1][4] = o[wx][wy][5];
			o[wx][wy - 1][5] = o[wx][wy][2];
			sum[wx][wy - 1] = sum[wx][wy] + d[o[wx][wy - 1][4]];
		}
		q.pop();
		if (q.empty())
		{
			return false;
		}
	}
	return true;
}
