/*
 * Николай Йорданов
 * 10 клас
 * Контролно състезание 2
 * задача cube
 */
#include <iostream>
#include <vector>
#include <climits>
#include <map>
#include <set>
#include <queue>

using namespace std;

class cube {
  public:
    int front, back, top, right, down, left;
    cube(int, int, int, int, int, int);
    
    cube north();
    cube south();
    cube east();
    cube west();
    
    bool operator== (cube) const;
    void operator= (cube);
};

cube::cube(int _f = 0, 
	   int _b = 0,
	   int _t = 0, 
	   int _r = 0, 
	   int _d = 0, 
	   int _l = 0) {
  
  front = _f;
  back = _b;
  top = _t;
  right = _r;
  down = _d;
  left = _l;
}

cube cube::north() {  return cube(down, top, front, right, back, left); }
cube cube::south() {  return cube(top, down, back, right, front, left); }
cube cube::east()  {  return cube(front, back, left, top, right, down); }
cube cube::west()  {  return cube(front, back, right, down, left, top); }  

bool cube::operator== (cube c) const {
  return (front == c.front && back == c.back   &&
	  top == c.top     && right == c.right &&
	  down == c.down   && left == c.left);
}

void cube::operator= (cube c) {
  front = c.front;
  back = c.back;
  top = c.top;
  right = c.right;
  down = c.down;
  left = c.left;
}


class pos {
  public:
    pos(int _x, int _y, cube _c) { x=_x; y=_y; c=_c; }
    pos(int _x, int _y) { x=_x; y=_y; }
    pos(int _x, int _y, cube _c, int _sum) { x=_x; y=_y; c=_c; sum=_sum; }
    
    
    int x, y;  // колони, редове
    int sum;
    int d;
    cube c;    
  
    void operator= (pos a)  { x = a.x; y = a.y; c = a.c; }
    bool operator< (pos a) const { return (x<a.x || (x==a.x && y<a.y) || (x==a.x && y==a.y && !(c==a.c))); }  // горе, ляво
    bool operator> (pos a)  { return (x>a.x || (x==a.x && y>a.y) || (x==a.x && y==a.y && !(c==a.c))); }  // долу, дясно
    bool operator==  (pos a) { return (x==a.x && y==a.y && c==a.c); }
    bool similar(pos a) { return (x==a.x && y==a.y); }  
    
    string toString();
};

string str(int a) {
  string res = "";
  if(a>9)
    res += (a/10 + '0');
  res += (a%10 + '0');
  
  return res;
}

string pos::toString() {
  string res = "";
  res += str(x);
  res += "|";
  res += str(y);
  res += "|";
  res += str(c.front);
  res += "|";
  res += str(c.back);
  res += "|";
  res += str(c.top);
  res += "|";
  res += str(c.right);
  res += "|";
  res += str(c.down);
  res += "|";
  res += str(c.left);
  
  return res;
}

bool debris[27][27];

int makecol(char c) {  return c - 'a' + 1; }
int makerow(string &s) { 
  int res = s[1] - '0';
  if(s.size() == 3) {
    res *= 10;
    res += (s[2] - '0');
  }
  
  return 26 - res +1;
}   

/*pos[16300] heap;
map<pos, int> heap_alloc;
map<pos, int> dist;
int heap_size;

void pop_heap() {
  swap( heap[0], heap[--heap_size] );
  heap_alloc[
  
  int cpos = 0;
  
  while(2*cpos < heap_size) {
    int cmove = 2*cpos + 1;
    if(cmove < heap_size && heap[cmove+1] < heap[cmove])
      cmove++;
    
    if(heap[cpos] > heap[cmove])
      swap[heap_cpos
  }
 */

int bfs( pos start, pos end) {
  int cbest = INT_MAX;
  int bestd = -1;
//   bool onefound = false;
  
  set<string> used;
  start.d = 0;
  queue<pos> q;
  q.push(start);
  used.insert(start.toString());
  
  int cnt =0;
  while(q.size()) {
    pos curr = q.front();
    q.pop();
    
//     cout<<curr.toString()<<" ";
    
    int o = curr.x, p=curr.y;
//     cout<<o<<" "<<p<<" "<<curr.d<<" "<<curr.sum<<endl;
//     for(int i=o-1; i<=o+1; i++) {
//       for(int j=p-1; j<=p+1; j++) 
// 	cout<<debris[i][j]<<" ";
//       cout<<endl;
//     }
    
    if(end.similar(curr)) {
      if(cbest > curr.sum) {
	if(bestd < 0 || (bestd > 0 && bestd == curr.d)) {
	  cbest = curr.sum;
	  bestd = curr.d;
	}
      }
    
    } else if((bestd > 0 && bestd <= curr.d) || bestd < 0) {
      
      if(curr.x>1) {
// 	cout<<debris[curr.x-1][curr.y]<<endl;
	if(!(debris[curr.x-1][curr.y])) {
// 	  cout<<"  север"<<endl;
	  pos n(curr.x-1, curr.y, (curr.c).north(), curr.sum + (curr.c).back);
	  
	  if(used.find(n.toString()) == used.end()) {
	    used.insert(n.toString());
	    n.d = curr.d + 1;
	    q.push(n);
	    
	  }
	  
// 	  if(curr.x == 22 && curr.y == 5) 
// 	    cout<<"*  "<<d[curr.toString()]<<" "<<d[n.toString()]<<endl;
	}
      }
      
      if(curr.y>1)
	if(!(debris[curr.x][curr.y-1])) {
// 	  cout<<"  запад"<<endl;
	  pos w(curr.x, curr.y-1, (curr.c).west(), curr.sum + (curr.c).left);
	  if(used.find(w.toString()) == used.end()) {
	    used.insert(w.toString());
	    w.d = curr.d + 1;
	    q.push(w);
	    
	  }
      }
      
      if(curr.y<26)
	if(!(debris[curr.x][curr.y+1])) {
// 	  cout<<"  изток"<<endl;
	  pos e(curr.x, curr.y+1, (curr.c).east(), curr.sum + (curr.c).right);
	  if(used.find(e.toString()) == used.end()) {
	    used.insert(e.toString());
	    e.d = curr.d + 1;
	    q.push(e);
	    
	  }
      }
      
      if(curr.x<26)
	if(!(debris[curr.x+1][curr.y])) {
// 	  cout<<"  юг"<<endl;
	  pos s(curr.x+1, curr.y, (curr.c).south(), curr.sum + (curr.c).front);
	  if(used.find(s.toString()) == used.end()) {
	    used.insert(s.toString());
	    s.d = curr.d + 1;
	    q.push(s);
	    
	  }
      }
    }
  }
  
//   cout<<bestd<<endl;

    
  if(cbest == INT_MAX)
    return -1;
  else
    return cbest;
  
}

int main() {
  
  string s, e;
  cin>>s>>e;
  
  int f,b,t,r,d,l;
  cin>>f>>b>>t>>r>>d>>l;
  
  cube first(f, b, t, r, d, l);
  
  pos start(makerow(s), makecol(s[0]), first, first.down);
  pos end  (makerow(e), makecol(e[0]));
  
  int fs;
  cin>>fs;
  for(int i=0; i<fs; i++) {
    string tmp;
    cin>>tmp;
    debris[makerow(tmp)][makecol(tmp[0])] = true;
//     cout<<makerow(tmp)<<" "<<makecol(tmp[0])<<endl;
  }
//   cout<<endl;
  
//   cout<<start.x<<" "<<start.y<<"  "<<end.x<<" "<<end.y<<endl;
//   for(int i=1; i<27; i++) {
//     for(int j=1; j<27; j++) 
//       if(i == start.x && j == start.y)
// 	cout<<"s ";
//       else if(i==end.x && j==end.y)
// 	cout<<"e ";
//       else
// 	cout<<debris[i][j]<<" ";
//     cout<<endl;
//   }
  
  cout<<bfs(start, end)<<endl;
  
  return 0;
}
