#include <iostream>
using namespace std;

typedef unsigned long long int lli;
lli mod;
lli mul(lli a, lli b)
{
  lli r=0, t=a%mod;
  while(b)
  {
    if(b&1) r=(r+t)%mod;
    b>>=1;
    t=2*t%mod;
  }
  return r;
}

void matmul(lli a[3][3], lli b[3][3], lli r[3][3])
{
  int i, j, k;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
    {
      r[i][j]=0;
      for(k=0; k<3; k++) r[i][j]=(r[i][j]+mul(a[i][k], b[k][j]))%mod;
    }
}

void step(lli a[3][3], lli n, lli r[3][3])
{
  lli t[3][3], k[3][3];
  int i, j;
  for(i=0; i<3; i++)
  {
    for(j=0; j<3; j++)
      { t[i][j]=a[i][j]%mod; r[i][j]=0; }
    r[i][i]=1;
  }
  
  while(n)
  {
    if(n%2)
    {
      matmul(r, t, k);
      for(i=0; i<3; i++) for(j=0; j<3; j++) r[i][j]=k[i][j];
    }
    n/=2;
    matmul(t, t, k);
    for(i=0; i<3; i++) for(j=0; j<3; j++) t[i][j]=k[i][j];
  }
}

int main()
{
  lli n;
  cin>>n>>mod;
  if(n==1) { cout<<1%mod<<endl; return 0; }
  if(n==2) { cout<<5%mod<<endl; return 0; }
  if(n==3) { cout<<11%mod<<endl; return 0; }
  lli a[3][3], r[3][3];
  a[0][0]=2; a[0][1]=1; a[0][2]=1;
  a[1][0]=1; a[1][1]=0; a[1][2]=0;
  a[2][0]=0; a[2][1]=1; a[2][2]=0;
  
  step(a, n-3, r);
  
  cout<<(mul(r[0][0], 13)+mul(r[0][1], 5)+(r[0][2]*2)%mod)%mod<<endl;
  return 0;
}
