#include <iostream>
using namespace std;

typedef long long int lli;
struct Kub
{
  lli front, back, left, right, top, bottom;
  void rotate_forward()
  {
    lli t=top;
    top=front;
    front=bottom;
    bottom=back;
    back=t;
  }
  void rotate_back()
  {
    lli t=top;
    top=back;
    back=bottom;
    bottom=front;
    front=t;
  }
  void rotate_left()
  {
    lli t=top;
    top=right;
    right=bottom;
    bottom=left;
    left=t;
  }
  void rotate_right()
  {
    lli t=top;
    top=left;
    left=bottom;
    bottom=right;
    right=t;
  }
  lli operator()(){return bottom; }
};

const lli inf=999999999999999999ll, ep=900;
lli d[28][28], d1[28][28];
int b[28][28];
int u[28][28];
Kub p[28][28], p1[28][28];
int sx, sy, fx, fy;
Kub starting;

int fordbellman()
{
  int i, j, q;
  Kub t;
  for(i=0; i<28; i++)
    for(j=0; j<28; j++)
      d[i][j]=inf;
  d[sx][sy]=starting();
  p[sx][sy]=starting;
  
  for(q=0; d[fx][fy]==inf && q<ep; q++)
  {    
    for(i=0; i<28; i++)
      for(j=0; j<28; j++)
	{ p1[i][j]=p[i][j]; d1[i][j]=d[i][j]; }
	
    for(i=1; i<=26; i++)
      for(j=1; j<=26; j++)
      {
	if(u[i][j] || d[i][j]==inf) continue;
	t=p[i][j];
	
	/*Trying to go left*/
	t.rotate_left();
	if(d[i][j]+t()<d1[i-1][j])
	{
	  d1[i-1][j]=d[i][j]+t();
	  p1[i-1][j]=t;
	  b[i-1][j]=1;
	}
	t.rotate_right();
	
	/*Trying to rotate right*/
	t.rotate_right();
	if(d[i][j]+t()<d1[i+1][j])
	{
	  d1[i+1][j]=d[i][j]+t();
	  p1[i+1][j]=t;
	  b[i+1][j]=-1;
	}
	t.rotate_left();
	
	/*Trying to rotate forward*/
	t.rotate_forward();
	if(d[i][j]+t()<d1[i][j-1])
	{
	  d1[i][j-1]=d[i][j]+t();
	  p1[i][j-1]=t;
	  b[i][j-1]=2;
	}
	t.rotate_back();
	
	/*Trying to rotate back*/
	t.rotate_back();
	if(d[i][j]+t()<d1[i][j+1])
	{
	  d1[i][j+1]=d[i][j]+t();
	  p1[i][j+1]=t;
	  b[i][j+1]=-2;
	}
	t.rotate_forward();
      }
      for(i=0; i<28; i++)
	for(j=0; j<28; j++)
	  { p[i][j]=p1[i][j]; d[i][j]=d1[i][j]; }
  }
  
  if(d[fx][fy]==inf) return -1;
  return d[fx][fy];
}

int main()
{
  char c1;
  cin>>c1>>sy;
  sx=c1-'a'+1;
  cin>>c1>>fy;
  fx=c1-'a'+1;
  cin>>starting.front>>starting.back>>starting.top>>starting.right>>starting.bottom>>starting.left;
  int n, x, y; cin>>n;
  for(int i=0; i<n; i++)
  {
    cin>>c1>>y;
    x=c1-'a'+1;
    u[x][y]=1;
  }
  
  cout<<fordbellman()<<endl;
  return 0;
}
